"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var operators_1 = require("rxjs/operators");
function HostElement() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    var config = (typeof args[args.length - 1] === "object" ? args.pop() : {});
    return function factory(proto, key) {
        var ngOnInit = proto.ngOnInit;
        var ngOnDestroy = proto.ngOnDestroy;
        var observer;
        var properties = (args.length > 0 ? args : [key.replace(/\$$/, "")]);
        proto.ngOnInit = function () {
            var _this = this;
            var target = config.selector ?
                this.element.nativeElement.querySelector(config.selector) : this.element.nativeElement;
            var updates = new rxjs_1.BehaviorSubject((args.length > 1 ? {} : null));
            setTimeout(function () {
                observer = new window.ResizeObserver(function (entries) { return updates.next(entries); });
                observer.observe(target);
            });
            var pipes = [
                operators_1.filter(function (entries) { return !!entries; }),
                operators_1.map(function (entries) {
                    return entries.length ? entries[0].contentRect : (properties.length > 1 ? {} : null);
                }),
                operators_1.filter(function (value) { return value !== null; }),
                operators_1.map(function (contentRect) {
                    return properties.reduce(function (list, arg) {
                        list[arg] = contentRect[arg];
                        return properties.length > 1 ? list : list[arg];
                    }, {});
                })
            ].concat((config.pipe || []));
            var updates$ = updates.pipe.apply(updates, pipes);
            if (config.observable === false) {
                if (properties.length > 1) {
                    this[key] = {};
                }
                updates$.subscribe(function (value) {
                    _this[key] = value;
                });
            }
            else {
                this[key] = updates$;
            }
            ngOnInit.call(this);
        };
        proto.ngOnDestroy = function () {
            observer.disconnect();
            ngOnDestroy.call(this);
        };
    };
}
exports.HostElement = HostElement;
